<?php
namespace Service;

use \SimpleXMLElement;

class PromocoesInt {

    protected $entityManager;
	protected $util;
	protected $PromocoesIntServiceAPI;
	
	public function __construct(
		\Doctrine\ORM\EntityManager $entityManager, 
		\Util\Util $util,
		\Odhen\API\Service\PromocoesInt $PromocoesIntServiceAPI
	){
		$this->entityManager = $entityManager;
		$this->util = $util;
		$this->PromocoesIntServiceAPI = $PromocoesIntServiceAPI;
	}
	public function EnviaCarrinhoPromocoesInt($arrParametros) {
		return $this->PromocoesIntServiceAPI->chamadaAPIPromocoesInt('sendCart',$arrParametros);
	}
	public function SalvaPromocoesInt($CDFILIAL,$NRVENDAREST,$NRCOMANDA,$NRCPFINTEPROMO,$IDPEDINTEPROMO,$arrPROMOCOMANDA) {
        $params = array (
            'CDFILIAL' => $CDFILIAL,
			'NRVENDAREST' => $NRVENDAREST,
			'NRCOMANDA' => $NRCOMANDA,
            'NRCPFINTEPROMO' => $NRCPFINTEPROMO,
            'IDPEDINTEPROMO' => $IDPEDINTEPROMO,
            'VRDESCFID' => null
        );
        $this->entityManager->getConnection()->fetchAssoc("UPDATE_COMANDAVEN_PROMO_INT", $params);
        if(!$IDPEDINTEPROMO || empty($arrPROMOCOMANDA)){
            $params = array (
                'CDFILIAL' => $CDFILIAL,
                'NRVENDAREST' => $NRVENDAREST,
                'NRCOMANDA' => $NRCOMANDA,
                'NRCPFINTEPROMO' => $NRCPFINTEPROMO,
                'IDPEDINTEPROMO' => $IDPEDINTEPROMO
            );
            $this->entityManager->getConnection()->fetchAssoc("DEL_PROMOCOMANDA_TUDO", $params);
        } else {
            $contador = 1;
            foreach ( $arrPROMOCOMANDA as $PROMOCOMANDA ){
                $PROMOCOMANDA['CDFILIAL'] = $CDFILIAL;
                $PROMOCOMANDA['NRVENDAREST'] = $NRVENDAREST;
                $PROMOCOMANDA['NRCOMANDA'] = $NRCOMANDA;
                $PROMOCOMANDA['NRSEQPROMOCOM'] = str_pad("".$contador, 3, '0', STR_PAD_LEFT);
                $contador = $contador + 1;
                $this->entityManager->getConnection()->fetchAssoc("INSERE_PROMOCOMANDA", $PROMOCOMANDA);
                if( $PROMOCOMANDA['IDUTPROMOCOM']=='S' && $PROMOCOMANDA['IDTPPROMOCOM']=='O'){
                    foreach ( $PROMOCOMANDA['products']['data'] as $arrProduto ){

                        $this->entityManager->getConnection()->fetchAssoc("UPDATE_COMANDAVEN_LIMPA_VRDESCFID", $params);

                        $arrProduto['VRDESCCOMVEN']='0';
                        $arrProduto['VRACRCOMVEN']='0';
                        $arrProduto['VRPRECCOMVEN']=$arrProduto['value'];
                        $arrProduto['QTPRODCOMVEN']=$arrProduto['quantity'];
                        $arrProduto['CDPRODUTO']=$arrProduto['productCode'];
                        $arrProduto['NRPRODCOMVEN']=$arrProduto['index'];
                        $arrProduto['CDFILIAL']=$CDFILIAL;
                        $arrProduto['NRVENDAREST']=$NRVENDAREST;
                        $arrProduto['NRCOMANDA']=$NRCOMANDA;
                        $this->entityManager->getConnection()->fetchAssoc("UPDATE_VALOR_DOS_ITENS_PROMOCOESINT", $arrProduto);
                    }
                }
            }
        }
		return array('error' => false,'message' => 'Informação salva com sucesso');
	}
	public function ConsultaPromocoesInt($arrParametros) {
		$arrRetorno =  $this->PromocoesIntServiceAPI->chamadaAPIPromocoesInt('consultCart',$arrParametros);
		return $arrRetorno;
    }
    public function BuscaPromocoesInt($CDFILIAL,$NRVENDAREST,$NRCOMANDA,$IDTPPROMOCOM) {
        $params = array(
            'CDFILIAL'=>$CDFILIAL,
            'NRCOMANDA'=>$NRCOMANDA,
            'NRVENDAREST'=>$NRVENDAREST
        );
        $arrPROMOCOMANDA = array();
        $dadosPROMOCOMANDA = $this->entityManager->getConnection()->fetchAll("GET_PROMOCOMANDA_TUDO", $params);
        foreach ( $dadosPROMOCOMANDA as $promocao ){
            if($promocao['IDTPPROMOCOM']=='O' && $IDTPPROMOCOM != 'T'){
                continue;
            }
            if($promocao['IDTPPROMOCOM']!= $IDTPPROMOCOM ){
                continue;
            }
            if($promocao['IDTPPROMOCOM']=='O'){
                $valor = $promocao['VRVENDAPROMO'];
            } else {
                $valor = $promocao['VRDESCPROMO'];
            }
            $promocao['dsVRPROMO'] = $valor;
            $promocao['DSIDTPDESCPROMO']='';
            if($promocao['IDTPDESCPROMO']=='P'){
                $promocao['dsVRPROMO'] = $valor.'%';
                $promocao['DSIDTPDESCPROMO']='%';
            } else if($promocao['IDTPDESCPROMO']=='V'){
                $valor=$this->util->formataPreco($valor);
                $promocao['dsVRPROMO'] = 'R$'.$valor;
                $promocao['DSIDTPDESCPROMO']='R$';
            }
            if($promocao['IDTPPROMOCOM']=='W' && empty($promocao['NMPROMOCOM'])){
                $promocao['NMPROMOCOM']= 'Carteira';
            }
            array_push($arrPROMOCOMANDA, $promocao);
        }
        return $arrPROMOCOMANDA;
    }
    public function AtualizaPromocoesInt($CDFILIAL,$NRVENDAREST,$NRCOMANDA,$NRSEQPROMOCOM,$IDUTPROMOCOM) {
        $params = array (
            'CDFILIAL' => $CDFILIAL,
			'NRVENDAREST' => $NRVENDAREST,
			'NRCOMANDA' => $NRCOMANDA,
            'NRSEQPROMOCOM' => $NRSEQPROMOCOM,
            'IDUTPROMOCOM' => $IDUTPROMOCOM
        );
        $this->entityManager->getConnection()->fetchAssoc("UPDATE_RESET_STATUS_PROMOCOMANDA", $params);
        $this->entityManager->getConnection()->fetchAssoc("UPDATE_STATUS_PROMOCOMANDA", $params);
		return array('error' => false,'message' => 'Informação salva com sucesso');
    }
}